#include <lua.h>
#include <lauxlib.h>

#include "lsup_rdf.h"

#ifndef _LUA_LSUP_H
#define _LUA_LSUP_H

/// Raise Lua error including LSUP error message on negative rc.
#define LUA_PCHECK(exp, message) do {\
    if ((exp) < LSUP_OK) \
        return luaL_error (L, "%s: %s", message, LSUP_strerror (exp)); \
} while (0)

// Size of printf("%p", <var>)
#define ADDR_BUF_SIZE sizeof (size_t) * 2 + 2
typedef char LSUP_AddrBuffer[ADDR_BUF_SIZE];


int term_to_string (lua_State *L, LSUP_Term *t)
{
    char *nt_term = NULL;
    CHECK (nt_codec.encode_term (t, NULL, &nt_term), fail);
    lua_pushfstring (L, "LSUP.Term @ %p %s", t, nt_term);

    return 1;

fail:
    if (nt_term) free (nt_term);
    return luaL_error (L, "Error encoding term for display!");
}


LSUP_Term **allocate_term (lua_State *L)
{
    LSUP_Term **tp = lua_newuserdatauv (L, sizeof (*tp), 1);
    luaL_getmetatable (L, "LSUP.Term");
    lua_setmetatable (L, -2);

    return tp;
}
#endif  // _LUA_LSUP_H
